/* $Id$
 *
 * History:37,34
 *
 * $Author$
 * $Date$
 * $Revision$
 *
 * Copyright (C) 1995 Pragmatic Designs, All Rights Reserved
 *
 * $Log$
 *
 */

#ifndef _PROTOTYP_H
#define _PROTOTYP_H

#ifdef	MAIN
#define EXTERN
#else
#define EXTERN extern
#endif

#define	SCRN_H	23						// screen height and width
#define	SCRN_W	23						// in hexes

void	fgHideCursor (void);
void	fgShowCursor (void);
int		fgTestButton (int button, Mouse* mouse);
void	fgMouseStat (Mouse* mouse);

void	initScreenMap (void);
void	drawGrid (void);
int		pointInHex (iPoint* result, const iPoint* mouse);
void	freeScreenMap (void);
void	labelGrid (void);
void	outlineHex (const iPoint* loc);
void	testPos (const iPoint* loc);

void	Error (char* s);

int		calcEvenMap (const iPoint* loc);
int		calcOddMap  (const iPoint* loc);
void	calcInfluence (int count);
void	showInfluence (void);

EXTERN	struct	_scrnMap*	scrnMap;	// handle for the screen map
EXTERN	struct	_iconMap*	iconMap;	// handle for the screen icons
EXTERN	struct	_gameMap*	gameMap;

EXTERN	int		oldMap[SCRN_H][SCRN_W];	// influence maps
EXTERN	int		newMap[SCRN_H][SCRN_W];
EXTERN	int		tstMap[SCRN_H][SCRN_W];	// where the mouse clicks happened


#endif


/* EOF - $RCSfile$ */
