-----------------------------A simple test-----------
//	World engine test
// (C) 1997 Aurel Balmosan

float Modify1(float a, float b)
{       return a*b*b;
}

float ModifyTree(float a, float b)
{       return (b>=0.25 && b<0.5 && a>0.5) ? a : 0.0;
}




class TWindow: public CtrlWindow
{       public:
          const int size=340;
          int   iter;
          LevelMap map;
          LevelMap mod;
          Brush br;

          class GenButton : public SimpleButton
          {     public: 
                        TWindow *w;

                void Init(TWindow *wx, int ax, int ay, int aw, int ah)
                {       GWindowInit(w=wx, ax, ay, aw, ah);
                        ButtonImage("Generate");
                }
                void Action() 
                {       w->Generate(); 
                        w->EventExpose(Rectangle(0,0,size,size)); 
                }
          }     GenButton;

          TWindow(GWindow* ap, int x, int y)
                : CtrlWindow(ap, x, y, size, size)
          {     map.SetSize(size, size);
                mod.SetSize(size, size);
                iter=size*size;
                Generate(); 
                GenButton.Init(this, 10, 10, 100, 30);
          }

          void Generate()
          {     int x=(int)time(NULL);
                printf("seed=%d\n", x);
                map.Generate(iter, x);
                mod.Generate(iter/2);
                map.Combine(&mod, Modify1);
                mod.Generate(iter/2);
                mod.Combine(&map, ModifyTree);
                for (int i=0; i<map.Height(); i++)
                {       for (int h=0; h<map.Width(); h++)
                        {       int k=4*256*map.Value(h, i)/LevelMap::fix1;
                                int kx=256*mod.Value(h, i)/LevelMap::fix1;
                                if (kx) map.Value(h,i)=RgbColor(0, 255-k/2, 0);
                                else if (k<128) map.Value(h, i)=RgbColor( 0,  0,   k+64);
                                else if (k<1*256) map.Value(h, i)=RgbColor( 0,  128+k/2,  0 );
                                else if (k<2*256) k-=1*256, map.Value(h, i)=RgbColor( 255-k, (255-k)
                                else if (k<3*256) k-=2*256, map.Value(h, i)=RgbColor( k/2+128, k*3/4
                                else              k-=3*256, map.Value(h, i)=RgbColor( k/2+128, k/2+1
                        }
                }

          }

          ~TWindow()
          {      }

          void EventExpose(const Rectangle& rec)
          {     Point   a;
                for (a.x=rec.x; a.x<rec.x+rec.width; a.x++)
                {       for (a.y=rec.y; a.y<rec.y+rec.height; a.y++)
                        {       br.Foreground(map.Value(a.x, a.y));
                                DrawPixel(&br, a.x, a.y);
                        }
                }
                GenButton.Paint();
          }     
};

