/* $Id$
 *
 * History:47,18
 *
 * $Author$
 * $Date$
 * $Revision$
 *
 * Copyright (C) 1995 Pragmatic Designs, All Rights Reserved
 *
 * $Log$
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <mem.h>

#include <fastgraf.h>
#include <fgfonts.h>

#include "struct.h"
#include "prototyp.h"


/****************************************************************
 * Handle any errors found.
 */
void
Error (char* s)
{
	fg_mousefin ();						// unhook the mouse driver

	freeScreenMap ();					// release map storage

	if (fg_getmode () != 3) {			// in graphics, (not text), mode
		fg_setmode (3);					// CO80
		fg_reset ();
	}

	fprintf (stderr, s);				// print the error message
	exit (1);
}


/* EOF - $RCSfile$ */
