from string import *
from proxy3_filter import *
import proxy3_options

class GeocitiesPopupFilter(BufferSomeFilter):
    BUFFER_LEN = 1024

    # Note: Yahoo is adding stuff past the </HTML>, so maybe we can
    # simply remove EVERYTHING after the end HTML tag ..
    def filter(self, s):
        if not proxy3_options.options.get('remove-geocities-popups', 0):
            return s

        s = remove_pattern(s, '<!-- Yahoo! Menu',
                           'END Yahoo! Menu Service -->')
        return s

from proxy3_util import *

register_filter('*geocities.com/*', 'text/html', GeocitiesPopupFilter)
