import re, cgi, urllib, cgi, time
from string import *
from proxy3_filter import *

def ignore_lookup_name(site):
    # Just try to look it up, but ignore all the errors
    try: lookup_name(site, use_alarm=0)
    except: pass

REQUESTS = []
def dns_lookup_thread():
    while 1:
        time.sleep(0.1)
        while not REQUESTS: time.sleep(0.2)
        r = REQUESTS[0]
        REQUESTS.remove(r) # Urgh, it'd be better as pop(), not in 1.5.1
        ignore_lookup_name(r)
        
class LinkFinder(BufferSomeFilter):
    def filter(self, s):
        output = []
        while 1:
            m = PAT1.search(s)
            if not m: break

            output.append(s[:m.end()])
            s = s[m.end():]
            
            url = m.group('url')
            if url[:7] == 'http://':
                site, document = stripsite(url)
                if find(site, ':') >= 0: site = site[:find(site, ':')]
                # Initiate async DNS here...?  Until we get real async dns:
                if not NameLookup.cache.has_key(site):
                    REQUESTS.append(site)

        return join(output, ''), s

from proxy3_util import *
from proxy3_dns import lookup_name, NameLookup
from proxy3_filter import register_filter
try:
    import thread
    register_filter('*', 'text/html', LinkFinder)
    thread.start_new_thread(dns_lookup_thread, ())
except ImportError:
    # Could not import the thread module, so we don't register the filter
    pass

# Ew, Python mode can't deal with font-locking this.
PAT1 = re.compile(r'''(?is)<a.*?href=['"]?(?P<url>.*?)['"\s>][^>]*>\s*''')
