def event_idle(connections):
    print ('|  0/%2d %s' % (len(connections), `connections`))[:79]
    
def event_status(ready_list, connections, conn):
    status = ''
    if ready_list is not None and connections is not None:
        status = ' %2d/%2d' % (len(ready_list), len(connections))
    print ('|%6s %s' % (status, `conn`))[:79]
    
def event_site_blocked(address, site, document):
    print "|-X-X-> Aborted:", site+document

def event_process_request(obj, site, document, request, headers):
    output = '|         %s%s' % (site, document)
    print output[:79]

def event_io_error(handler, err, context=''):
    print '!       '+context+'I/O Error', err.errno, '--', err.strerror

def event_socket_error(handler, err):
    print '*  ***  Socket Error:', err

def event_unix_error():
    # print '|         Unix is stupid. ',
    # print 'See http://www.jwz.org/worse-is-better.html'
    pass

def event_kill_stale_handler(handler):
    print '*      Killing', `handler`

def event_unknown_request(handler, request):
    print '    ??? '+request[:70]

def event_extra_form_data(handler, data):
    print '|     * Extra data being sent:',`data`[:40]

def event_ad_removed(url, tag):
    from proxy3_util import shorten_url
    h = '|         Removed %s:' % tag
    print h, shorten_url(url, 79-len(h))
